#ifdef __linux__
/* Miquel van Smoorenburg, <miquels@drinkel.cistron.nl> and others wrote */
/* the following two functions. The source package of sysvinit contained */
/* this specific chunk. */

#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "initreq.h"

#define PWRSTAT "/etc/powerstatus"
#define PWRFAIL "/etc/powerfail"

void alrm_handler()
{
}

void powerfail(int ok)
{
  int fd;
  struct init_request req;

  /* Fill out the request struct. */
  memset(&req, 0, sizeof(req));
  req.magic = INIT_MAGIC;
  req.cmd   = ok ? INIT_CMD_POWEROK : INIT_CMD_POWERFAIL;
          
  /* Open the fifo (with timeout) */
  signal(SIGALRM, alrm_handler);
  alarm(3);
  if ((fd = open(INIT_FIFO, O_WRONLY)) >= 0
            && write(fd, &req, sizeof(req)) == sizeof(req)) {
    close(fd);
    #ifdef UPSLESS_TEST
    printf("I told init\n");
    #endif
    return;
  }

  if(ok) {
    unlink(PWRFAIL);
  }
  else {
    if((fd=creat(PWRFAIL,0644)) >= 0) {
      write(fd,"FAIL\n",5);
      close(fd);
    }
  }
  /* Create an info file needed by init to shutdown/cancel shutdown */
  unlink(PWRSTAT);
  if ((fd = open(PWRSTAT, O_CREAT|O_WRONLY, 0644)) >= 0) {
    if (ok) write(fd, "OK\n", 3);
    else write(fd, "FAIL\n", 5);
    close(fd);
  }
  kill(1, SIGPWR);
}
#else
void powerfail(int ok) {}
#endif
