/* (c) Nic Roets (ups@geo.co.za or geo@pta.lia.net), GPL2 applies. */
/* This is a daemon that should be a bit more portable (HP-UX hopefully). */
#include <signal.h>
#include <stdio.h>
#include "powerdChunk.h"
#include "tcpphone.h"

void Do(const char *cmd)
{
  int status;
  
  if(cmd[0]=='-') {
    switch(cmd[1]) {
      case 'd':powerfail(0); break;
      case 'u':powerfail(1); break;
      /* ignore -i and others */
    }
  }
  else {
    if(fork()) wait(&status);
    else execl("/bin/sh","/bin/sh","-c",cmd);
  }
}

void main(int argc, const char *argv[])
{
  char line[80],*ptr=line;
  int shuttingDown=0,fd,daemon=0,tmp;
  
  if(argc<5) {
    fprintf(stderr,
    "%s runs on a computer that has an interruptible power supply, but is\n"
    "not connected to it directly. The smartups daemon runs on the machine\n"
    "that is connected to it thou. It can be used to warn users, and start/\n"
    "stop shutdowns. It always takes 4 parameters :\n"
    "It's first parameter is the name of the computer running smartups.\n"
    "The last three parameters, should either be a command xx that can be\n"
    "executed with /bin/sh -c xx, or they should be -i for ignore or -d to\n"
    "tell init to start the shutdown or -u to tell init to stop the\n"
    "shutdown. The first one is the action to take when the power fails.\n"
    "The second one is the action to take only when the shutdown is\n"
    "scheduled irreversibly, and the third is the action to take when the\n"
    "power is restored\n"
    "Here is 3 examples that can be used in /etc/rc.d/rc.local :\n"
    "%s r2d2 \"shutdown -h +5 \\\"ON\\\"\" -i \"shutdown -c \\\"OFF\\\"\"\n"
    "%s r2d2 -d -i -u\n"
    "%s r2d2 -i \"shutdown -h 0\" -i \n",
    argv[0],argv[0],argv[0],argv[0]);
    return;
  }
  signal(SIGPIPE,SIG_IGN);
  while(1) {
    while((fd=TCPPhone(argv[1],"UPSstats"))<0) {
      if(!daemon) {
        fprintf(stderr,
          "ATTENTION : Make sure %s is running smartups\n",argv[1]);
        if(fork()) exit(1);
        else setsid();
        daemon=1;
      }
      sleep (1);
    }
    while(read(fd,ptr,1)==1) {
      if(*ptr!='\n') {
        if(ptr-line<sizeof(line)-1) ptr++;
      }
      else {
        *ptr='\0';
        ptr=line;
        if(!daemon) {
          printf("%s : %s\n",argv[1],line);
          if(fork()) exit(0);
          else setsid();
          daemon=1;
        }
        tmp=memcmp(line,"Ups WILL ",9)==0;
        if(!shuttingDown && (memcmp(line,"Supply Of",9)==0 || tmp)) {
          if(shuttingDown==0) {
            Do(argv[2]);
            shuttingDown=1;
          }
        }
        if(shuttingDown<=1 && tmp) {
          Do(argv[3]);
          shuttingDown=2;
        }
        else if(memcmp(line,"Supply On",9)==0 && shuttingDown) {
          Do(argv[4]);
          shuttingDown=0;
        }
      }
    }
    close(fd);
  }
}

