.TH "smartups" "8" "June 13,1997" "Linux manpage" "SMARTUPS"
.SH "NAME smartups \- Power failures become spectacular and non-disastrous"
.SH "SYNOPSIS"
\fBsmartups\fP
.SH "DESCRIPTION"
This man page describes the \fBsmartups\fP program. It's first purpose is
to start a shutdown when necessary, and tell the UPS, when the shutdown
was started, to remove power from the computer after a specified period.
The second purpose is to provide information about the power situation to
clients across a network. \fBgraph\fP can then plot the data.
.PP
\fBsmartups\fP works only with a UPS that can be controlled by the
"Safeware" software or the "PowerAlert for TrippLite UPSs" software.
To use it on your system, you must:
.IP o
Connect it to your computer with a standard serial cable. (Don't plug
the power cable of the computer into the UPS yet.) A "TrippLite"
UPS may need a special cable, often supplied with the UPS.
.IP o
Create a file called /etc/power. This file should contain one line eg.
/dev/ttyS0 30 3 240 300
.PP
1. This entry is the serial port to which the UPS is connected.
.PP
2. This entry is the number of seconds that the UPS must wait
(measured from the start the shutdown) before turning off its outputs.
A value of 30+(number of seconds a shutdown takes) should be more than
enough.
.PP
3. This is the minimum number of minutes that the UPS will remain
down for, even if the power returns immediately. The UPS should be able
to recharge somewhat in this time incase of a secondary failure (not
implemented for "TrippLite").
.PP
4. This is 110 for the USA and 220 for Europe. It is currently not used.
.PP
5. This is the number of seconds that the program may wait from the
start of the powerfailure before starting the shutdown. It is only
during this period that a restoration of the power will be detected and
acted upon. Entry 2 plus entry 5 should be less than the rated
time (for the given load) of the UPS. The program will write to all the
consoles 5 and 1 minutes before the shutdown is started, and when the
power is back.
.IP o
Make an entry for "UPSstats" in /etc/services. You can use any port
number not already in use. I use port number 20050.
.IP o
Type "make" in source directory. Move Graph to /usr/lib/X11/app-defaults
or append it to .Xdefaults. Then you can type "mv smartups /sbin"
and "mv graph /usr/bin" if you do not like full path names.
.IP o
You can now run smartups and see if it recognizes your UPS. It
will print the first line of statistics if everything goes right. If
you have got the wrong serial port or something, edit /etc/power again,
find it's process id (pid) with "ps" and do a "kill -HUP pid". You can
then type "telnet localhost 20050" (or "graph" if you have an X server)
to see if you fixed the problem, and what the statistics are. Type
"Ctrl-] quit" to get out of the telnet session.
.IP o
If it all works, put smartups in /etc/rc.d/rc.local.
.IP o
Edit the powerfail entry in /etc/inittab. Remember that the power may
have failed a few minutes ago (see parameter 5), a letting shutdown
delay the process any futher is useless.
.IP o
Test a few possibilities, like the power failing and returning just
before or just after the shutdown is started. \fBsmartups\fP is designed
so that you will never need to manually restart the computer.
.IP o
Plug the computer into the UPS and examine the load figures. The load
value a TrippLite reports will remain constant when the power fails,
but the load value doubles approximately when the supply fails for
other UPSs.
.SH "OPTIONS"
.SH "FILES"
/etc/power /etc/inittab /dev/initctl
.SH "SEE ALSO"
powerd shutdown init graph.c
.SH "DIAGNOSTICS"
Do a kill -USR1 `pidof smartups` to start a shutdown and scheduling the
cutting of the power. A the program ignores a TERM signal, so that it can
keep on reporting during the last few seconds of the shutdown process.
Since it does not do any file writes, a KILL signal can be used without
danger.
.SH "BUGS"
The "hottentotsgot" lives in South-Africa.
.PP
The battery figure can be of by about 10 %, so make conservative estimates.
.SH "AUTHOR"
Nic Roets
.PP
Send mail (and promises of pizza and money :-() to ups@geo.co.za
