#include <errno.h>
#include <stdio.h>

#include <sys/types.h> /* HP_UX needs these before netinet */
#include <sys/time.h>
#include <string.h>

#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include "tcpphone.h"

int TCPPhone(const char *host,const char *service)
{
  int fd;
  struct sockaddr_in sa;
  struct hostent *he;
  struct servent *sp;
  
  sa.sin_family = AF_INET;
  if((fd=socket(PF_INET,SOCK_STREAM,0))==-1) { /* is 0 ip or default ? */
    perror("socket");
    return -1;
  }
  he=gethostbyname(host);
  if(he==NULL) {
    fprintf(stderr,"Unknown host %s.\n",host);
    return -2;
  }
  if ((sp=getservbyname (service, "tcp"))==NULL) {
    fprintf(stderr,"Please make an entry for %s in"
      " /etc/services\n", service);
    return -3;
  }
                
  sa.sin_family=AF_INET;
  sa.sin_port=sp->s_port;
  sa.sin_addr= *(struct in_addr *) he->h_addr;
  if(connect(fd,(struct sockaddr *)&sa,sizeof(sa))!=0) {
    fprintf(stderr,"%s : %s's %s service\n",strerror(errno),host,service);
    return -4;
  }
  return fd;
}
