/* (c) Nic Roets (nic@geo.asd.co.za), GPL2 applies. */
/* writeDaemon makes it easy to write a daemon that monitors some device */
/* and will tell everyone that wants to know about that device its status.*/
/* It uses network sockets to make the status information available to */
/* clients. It is stable in the sense that when a client dies or forgets */
/* to remove their input data, it will disconnect that client and continue */
/* to monitor the device and to talk the other clients. */
/* It will reconfigure the device when receiving a SIGHUP. A secure daemon*/
/* should set it's effective user id when possible, but this module does */
/* nothing in that regard. */

/* writerDaemon is the main function, and therefore it requires some other */
/* file to supply the following functions/variables. This is a bit */
/* "agterste voor", but it makes things a lot easier. */
#ifndef WRITERDAEMON_H
#define WRITERDAEMON_H
extern const char *writerServiceName; /* Entry in /etc/services */
void Configure(void); /* Read some file in /etc. Can be called repeatedly */
const char *Monitor(void);
/* Called once every second. It should generate a message (with a zero */
/* terninator) for possible clients. Writing one line ASCII that ends with */
/* a "\r\0" is a good idea, because someone can then access the port with */
/* telnet. Currently I do not know how to tell telnet that I want to end */
/* the sessions :-( */
#endif

